import os
os.chdir(r'C:\Users\Aki\source\repos\acoustic_model\acoustic_model')

import sys
import csv
#import subprocess
#from collections import Counter
#import re

import numpy as np
import pandas as pd
#import matplotlib.pyplot as plt
#from sklearn.metrics import confusion_matrix

import acoustic_model_functions as am_func
import convert_xsampa2ipa
import defaultfiles as default

from forced_alignment import pyhtk, convert_phone_set

import novoapi 


## ======================= novo phoneset ======================
translation_key = dict()

#phonelist_novo70_      = pd.ExcelFile(default.phonelist_novo70_xlsx)
#df = pd.read_excel(phonelist_novo70_, 'list')
## *_simple includes columns which has only one phone in.
#for ipa, novo70 in zip(df['IPA_simple'], df['novo70_simple']):
#    if not pd.isnull(ipa):
#        print('{0}:{1}'.format(ipa, novo70))
#        translation_key[ipa] = novo70
#phonelist_novo70 = np.unique(list(df['novo70_simple']))

phoneset_ipa = []
phoneset_novo70 = []
with open(default.novo70_phoneset, "rt", encoding="utf-8") as fin:
	lines = fin.read()
	lines = lines.split('\n')
	for line in lines:
		words = line.split('\t')
		if len(words) > 1:
			novo70 = words[0]
			ipa	   = words[1]
			phoneset_ipa.append(ipa)
			phoneset_novo70.append(novo70)
			translation_key[ipa] = novo70
phoneset_ipa    = np.unique(phoneset_ipa)
phoneset_novo70 = np.unique(phoneset_novo70)

# As per Nederlandse phoneset_aki.xlsx recieved from David
# [ɔː] oh / ohr
# [ɪː] ih / ihr
# [iː] iy
# [œː] uh
# [ɛː] eh
david_suggestion = ['ɔː', 'ɪː', 'iː', 'œː', 'ɛː']


## ======================= convert phones ======================
mapping = convert_xsampa2ipa.load_converter('xsampa', 'ipa', default.ipa_xsampa_converter_dir)

stimmen_transcription_ = pd.ExcelFile(default.stimmen_transcription_xlsx)
df = pd.read_excel(stimmen_transcription_, 'check')
#for xsampa, ipa in zip(df['X-SAMPA'], df['IPA']):
#    ipa_converted = convert_xsampa2ipa.xsampa2ipa(mapping, xsampa)
#    if not ipa_converted == ipa:
#        print('{0}: {1} - {2}'.format(xsampa, ipa_converted, ipa))
transcription_ipa = list(df['IPA'])

# transcription mistake?
transcription_ipa = [ipa.replace(';', ':') for ipa in transcription_ipa if not ipa=='pypɪl' and not pd.isnull(ipa)]
transcription_ipa = [ipa.replace('ˑ', '') for ipa in transcription_ipa] # only one case.

not_in_novo70 = []
for ipa in transcription_ipa:
	ipa = convert_phone_set.split_ipa(ipa)

	not_in_novo70_ = [phone for phone in ipa 
				   if not phone in phoneset_ipa and not phone in david_suggestion]
	not_in_novo70_ = [phone.replace('sp', '') for phone in not_in_novo70_]
	not_in_novo70_ = [phone.replace(':', '') for phone in not_in_novo70_]
	not_in_novo70_ = [phone.replace('ː', '') for phone in not_in_novo70_]

	#translation_key.get(phone, phone)
	not_in_novo70.extend(not_in_novo70_)
not_in_novo70_list = list(set(not_in_novo70))


def search_phone_ipa(x, phone_list):
	return [phone for phone in phone_list if x in convert_phone_set.split_ipa(phone)]


# 'ɐ', 'ɒ', 'w', 'æ', 'ʀ', 'ʁ', 
# 'œː', 'ɾ', 
# 'o', 'a'
# [e] 'nyːver mɑntsjə' (1)
# [ɹ] 'iːjəɹ' (2)

search_phone_ipa('ˑ', transcription_ipa)